Subject: Re: bug#72701: eglot crash when project-files-relative-names t

From: João Távora <[email-masked]>
Date: Fri, 23 Aug 2024 16:08:15 +0100

On Fri, Aug 23, 2024 at 3:56 PM Ship Mints <[email-masked]> wrote:
>
> Glad I set project-files-relative-names to t and have been testing. This side-effect in Eglot is sure to bite other people who are teased by the NEWS of this new option, despite not being a defcustom.

If it's not a defcustom and, as Dmitry said, not meant to be set by the user,
I suggest you _don't_ set it globally, but ask for it to be let-bound
in whatever
features you want to make use of it.

Eglot could be one of those features if there's a performance advantage.
But I doubt it, because server-supplied glob expressions may target the
full file name (indeed likely the truename).  Maybe it's worth it nevertheless,
dunno.  Anyway while let-binding p-f-r-names to nil in Eglot could work, I
don't think it's the right solution, especially since it probably triggers a
compilation warning in older Emacsen which don't have this.

Unrelated, there are other enhancements to Eglot's file-watching
machinery.  One of them is about excluding files from over-eager watching
by the server which could eventually bump into OS limits for these
OS objects.

João Távora